/* mpTree 0.1.2
 * -----------[ http://mptree.netpedia.net
 *
 *   Use this software at your own risk!
 *    This software falls under the GPL.
 *   Read COPYING for further informations.
 */

#include "mptree.h"
#include "icons/mptree.xpm"

GtkItemFactory *menubar_itemfactory;

void create__menubar()
{
   GtkWidget *menubar;
   GtkAccelGroup *accel_group;
   static GtkItemFactoryEntry menu_items[] = {
      { "/_File",         NULL,         NULL, 0, "<Branch>" },
      { "/File/_New",     "<control>N", new_database, 0, NULL },
      { "/File/_Open",    "<control>O", open_database_button, 0, NULL },
      { "/File/_Save",    "<control>S", save_database_button, 0, NULL },
      { "/File/sep1",     NULL,         NULL, 0, "<Separator>" },
      { "/File/Quit",     "<control>Q", exit_appl, 0, NULL },
      { "/_Database",      NULL,         NULL, 0, "<Branch>" },
      { "/Database/Add _Medium",  NULL, add_files_to_tree_selected, 0, NULL },
      { "/Database/sep2",	NULL,	NULL,	0, "<Separator>" },
      { "/Database/Add Item to _songList", NULL, to_songlist, 0, NULL },
      { "/Database/Add Item to _GQmpeg's Playlist",  "<control>A", add_to_external_playlist, 0, NULL },
      { "/Song_List",      NULL,         NULL, 0, "<Branch>" },
      { "/SongList/Move _up",  NULL, sl_move_up, 0, NULL },
      { "/SongList/Move _down", NULL, sl_move_down, 0, NULL },
      { "/SongList/_Clear",         NULL,         clear_sl, 0, NULL },
      { "/SongList/sep2",	NULL,	NULL,	0, "<Separator>" },
      { "/SongList/_Add to GQmpeg's Playlist",  NULL, add_sl_to_epl, 0, NULL },
      { "/_Help",         NULL,         NULL, 0, "<LastBranch>" },
      { "/_Help/About",   NULL,         show_about_box, 0, NULL },
   };
   gint numb_of_items = sizeof (menu_items) / sizeof (menu_items[0]);

   accel_group = gtk_accel_group_new ();
   menubar_itemfactory = gtk_item_factory_new (GTK_TYPE_MENU_BAR, "<main>",
                        accel_group);
   gtk_item_factory_create_items (menubar_itemfactory, numb_of_items, menu_items, NULL);
   gtk_accel_group_attach (accel_group, GTK_OBJECT (mainwin));

   if (menubar)
      menubar = gtk_item_factory_get_widget (menubar_itemfactory, "<main>");

   gtk_box_pack_start(GTK_BOX(box), menubar, FALSE, FALSE, TRUE);
}

void add_files_to_tree_selected()
{
  GtkWidget *frame, *hbox;
  GtkWidget *labelbox, *pathlabel, *mediumlabel;
  GtkWidget *buttonbox, *cancel_button, *ok_button;
  GtkWidget *entrybox;
  
  addfileswin=gtk_window_new(GTK_WINDOW_TOPLEVEL);
  gtk_container_border_width (GTK_CONTAINER(addfileswin), 5);
  gtk_window_set_title(GTK_WINDOW(addfileswin), "Add files");
  frame=gtk_frame_new("Add files");
  gtk_frame_set_shadow_type( GTK_FRAME(frame), GTK_SHADOW_ETCHED_OUT);
  gtk_container_add(GTK_CONTAINER(addfileswin), frame);
  
  hbox=gtk_hbox_new(FALSE, 3);
  gtk_container_add(GTK_CONTAINER(frame), hbox);
  
  labelbox=gtk_vbox_new(FALSE, 3);
  gtk_box_pack_start(GTK_BOX(hbox), labelbox, TRUE, TRUE, TRUE);
  pathlabel=gtk_label_new("Location");
  gtk_label_set_justify(GTK_LABEL(pathlabel), GTK_JUSTIFY_RIGHT); 
  mediumlabel=gtk_label_new("Mediumname");
  gtk_label_set_justify(GTK_LABEL(mediumlabel), GTK_JUSTIFY_RIGHT);
  gtk_box_pack_start(GTK_BOX(labelbox), pathlabel, FALSE, FALSE, TRUE);
  gtk_box_pack_start(GTK_BOX(labelbox), mediumlabel, FALSE, FALSE, TRUE);

  entrybox=gtk_vbox_new(FALSE, 3);
  gtk_box_pack_start(GTK_BOX(hbox), entrybox, TRUE, TRUE, TRUE);
  pathentry=gtk_entry_new();
  mediumentry=gtk_entry_new();
  gtk_box_pack_start(GTK_BOX(entrybox), pathentry, TRUE, TRUE, TRUE);
  gtk_box_pack_start(GTK_BOX(entrybox), mediumentry, TRUE, TRUE, TRUE);
  
  buttonbox=gtk_vbox_new(FALSE, 3);
  gtk_box_pack_start(GTK_BOX(hbox), buttonbox, FALSE, FALSE, TRUE);
  ok_button=gtk_button_new_with_label("OK");
  gtk_signal_connect(GTK_OBJECT(ok_button),
    "clicked",
     GTK_SIGNAL_FUNC(add_files_ok_pressed),
     NULL);
  cancel_button=gtk_button_new_with_label("Cancel");
  gtk_signal_connect(GTK_OBJECT(cancel_button),
    "clicked",
     GTK_SIGNAL_FUNC(add_files_cancel_pressed),
     NULL);
  gtk_box_pack_start(GTK_BOX(buttonbox), ok_button, FALSE, FALSE, TRUE);
  gtk_box_pack_start(GTK_BOX(buttonbox), cancel_button, FALSE, FALSE, TRUE);

  gtk_widget_show_all(addfileswin);
}

void add_files_ok_pressed()
{
  char *media, *path;
  unsigned int sc=0;
  char *text[6];
  char d, h, m, s;

  path=gtk_entry_get_text(GTK_ENTRY(pathentry));
  media=gtk_entry_get_text(GTK_ENTRY(mediumentry));

  sc = add_files_recursive(path, path, max_row_medialist+1);

  if (sc > 0)
  {
    max_row_medialist = max_row_medialist + 1;
    text[1] = (char *) malloc (8);
    text[2] = (char *) malloc (8);
    text[3] = (char *) malloc (14);
    text[5] = NULL;
    text[0] = media;
    sprintf(text[1], "%d",sc); 
    sprintf(text[2], "%dMB", (int) abs(media_size));
    dhms_time(media_sl, &d, &h, &m, &s);
    sprintf(text[3], "%02dd%02dh%02dm%02ds", d, h, m, s);
    text[4] = path;
    add_medialist_item(text);

    sort_soundtracks(max_row_medialist);
    gtk_ctree_sort_recursive(GTK_CTREE(ctree), root);
    if (!av_root)
    {
      text[0] = (char *) "Available mp3";
      av_root = gtk_ctree_insert_node(GTK_CTREE(ctree), NULL, NULL, text, 5,
				 GTK_PIXMAP(dbicon)->pixmap, NULL,
				 GTK_PIXMAP(dbicon)->pixmap, NULL,
				 FALSE, TRUE);

    }
    gtk_widget_hide(ctree);
    add_medium_to_node(GTK_CTREE(ctree), av_root, max_row_medialist);
    gtk_widget_show(ctree);

    sprintf(message, "Added %d files (%.2fMB)", sc, media_size);
    gtk_statusbar_push(GTK_STATUSBAR(statusbar), 1, message);
    media_size = 0;
    media_sl = 0;
  }
  
  gtk_widget_destroy(GTK_WIDGET(addfileswin));
}

void add_files_cancel_pressed()
{
  gtk_widget_destroy(GTK_WIDGET(addfileswin));
}

void to_songlist()
{
    if ((!selected_tree_item) || (selected_tree_item == root)) return;
    
    else if (!(GTK_CTREE_ROW(selected_tree_item)->children)) add_songlist_item(selected_tree_item); //selected is song
    else if(GTK_CTREE_ROW( GTK_CTREE_ROW(selected_tree_item)->children )->children)
      send_artist_to_list(selected_tree_item, SONGLIST);
    
    else send_album_to_list(selected_tree_item, SONGLIST); //selected is album 

}

void add_to_external_playlist()
{
    if ((!selected_tree_item) || (selected_tree_item == root)) return;
    
    else if (!(GTK_CTREE_ROW(selected_tree_item)->children)) send_song_to_external_playlist(selected_tree_item); //selected is song
    
    else if(GTK_CTREE_ROW( GTK_CTREE_ROW(selected_tree_item)->children )->children)
      send_artist_to_list(selected_tree_item, GQMPEG);
    
    else send_album_to_list(selected_tree_item, GQMPEG); //selected is album 
}

void show_about_box()
{
  GtkWidget *vbox, *separator, *label, *labelbig, *logo;
  GtkStyle *style;
  GdkPixmap *logopixmap;
  GdkBitmap *logomask;

  about_box=gtk_window_new(GTK_WINDOW_TOPLEVEL);
  gtk_container_border_width (GTK_CONTAINER(about_box), 5);
  gtk_window_set_title(GTK_WINDOW(about_box), "About");

  vbox = gtk_vbox_new(FALSE, 5);
  gtk_container_add(GTK_CONTAINER(about_box), vbox);
  
  style = gtk_widget_get_style(about_box);
  logopixmap = gdk_pixmap_create_from_xpm_d(mainwin->window, &logomask, 
             &style->bg[GTK_STATE_NORMAL], (gchar **) mptree_logo_xpm);
  logo = gtk_pixmap_new(logopixmap, logomask);
  gtk_box_pack_start(GTK_BOX(vbox), logo, FALSE, TRUE, 0); 
  
  labelbig = gtk_label_new("mpTree");
  //style->font=gdk_font_load("-adobe-courier-medium-r-normal-*-32-*-*-*-m-*-iso8859-1");
  gtk_widget_set_style(labelbig, style);
  gtk_box_pack_start(GTK_BOX(vbox), labelbig, FALSE, TRUE, 0);

  label = gtk_label_new("version 0.1.2");
  gtk_box_pack_start(GTK_BOX(vbox), label, FALSE, TRUE, 0);
  separator = gtk_hseparator_new();
  gtk_box_pack_start(GTK_BOX(vbox), separator, FALSE, TRUE, 0);
  label = gtk_label_new("little mp3-database managing program");
  gtk_box_pack_start(GTK_BOX(vbox), label, FALSE, TRUE, 0);
  label = gtk_label_new("Homepage: http://mptree.netpedia.net");
  gtk_box_pack_start(GTK_BOX(vbox), label, FALSE, TRUE, 0);
  label = gtk_label_new("Authors: Martin Wiesinger <genivs@gmx.net>");
  gtk_box_pack_start(GTK_BOX(vbox), label, FALSE,  TRUE, 0);
  label = gtk_label_new("         Selinger Daniel <rockz@gmx.net>");
  gtk_box_pack_start(GTK_BOX(vbox), label, FALSE, TRUE, 0);
  
  gtk_widget_show_all(about_box);
}

void disable_mb_items(int notebookpage)
{
   switch (notebookpage)
   {
      case 0: gtk_widget_set_sensitive( gtk_item_factory_get_item(menubar_itemfactory, "/File/New"), TRUE);
   	      gtk_widget_set_sensitive( gtk_item_factory_get_widget(menubar_itemfactory, "/File/Open"), TRUE);
              gtk_widget_set_sensitive( gtk_item_factory_get_widget(menubar_itemfactory, "/File/Save"), TRUE);
              gtk_widget_set_sensitive( gtk_item_factory_get_widget(menubar_itemfactory, "/Database/Add Medium"), TRUE);
              gtk_widget_set_sensitive( gtk_item_factory_get_widget(menubar_itemfactory, "/Database/Add Item to songList"), TRUE);
	      gtk_widget_set_sensitive( gtk_item_factory_get_widget(menubar_itemfactory, "/Database/Add Item to GQmpeg's Playlist"), TRUE);
	      gtk_widget_set_sensitive( gtk_item_factory_get_widget(menubar_itemfactory, "/SongList/Move up" ), FALSE);
	      gtk_widget_set_sensitive( gtk_item_factory_get_widget(menubar_itemfactory, "/SongList/Move down"), FALSE);
	      gtk_widget_set_sensitive( gtk_item_factory_get_widget(menubar_itemfactory, "/SongList/Clear"), FALSE);
	      gtk_widget_set_sensitive( gtk_item_factory_get_widget(menubar_itemfactory, "/SongList/Add to GQmpeg's Playlist"), FALSE);
	      break;

      case 1: gtk_widget_set_sensitive( gtk_item_factory_get_widget(menubar_itemfactory, "/File/New"), TRUE);
   	      gtk_widget_set_sensitive( gtk_item_factory_get_widget(menubar_itemfactory, "/File/Open"), TRUE);
              gtk_widget_set_sensitive( gtk_item_factory_get_widget(menubar_itemfactory, "/File/Save"), TRUE);
              gtk_widget_set_sensitive( gtk_item_factory_get_widget(menubar_itemfactory, "/Database/Add Medium"), TRUE);
              gtk_widget_set_sensitive( gtk_item_factory_get_widget(menubar_itemfactory, "/Database/Add Item to songList"), FALSE);
	      gtk_widget_set_sensitive( gtk_item_factory_get_widget(menubar_itemfactory, "/Database/Add Item to GQmpeg's Playlist"), FALSE);
	      gtk_widget_set_sensitive( gtk_item_factory_get_widget(menubar_itemfactory, "/SongList/Move up" ), FALSE);
	      gtk_widget_set_sensitive( gtk_item_factory_get_widget(menubar_itemfactory, "/SongList/Move down"), FALSE);
	      gtk_widget_set_sensitive( gtk_item_factory_get_widget(menubar_itemfactory, "/SongList/Clear"), FALSE);
	      gtk_widget_set_sensitive( gtk_item_factory_get_widget(menubar_itemfactory, "/SongList/Add to GQmpeg's Playlist"), FALSE);
	      break;

      case 2: gtk_widget_set_sensitive( gtk_item_factory_get_widget(menubar_itemfactory, "/File/New"), FALSE);
   	      gtk_widget_set_sensitive( gtk_item_factory_get_widget(menubar_itemfactory, "/File/Open"), FALSE);
              gtk_widget_set_sensitive( gtk_item_factory_get_widget(menubar_itemfactory, "/File/Save"), FALSE);
              gtk_widget_set_sensitive( gtk_item_factory_get_widget(menubar_itemfactory, "/Database/Add Medium"), FALSE);
              gtk_widget_set_sensitive( gtk_item_factory_get_widget(menubar_itemfactory, "/Database/Add Item to songList"), FALSE);
	      gtk_widget_set_sensitive( gtk_item_factory_get_widget(menubar_itemfactory, "/Database/Add Item to GQmpeg's Playlist"), FALSE);
	      gtk_widget_set_sensitive( gtk_item_factory_get_widget(menubar_itemfactory, "/SongList/Move up" ), TRUE);
	      gtk_widget_set_sensitive( gtk_item_factory_get_widget(menubar_itemfactory, "/SongList/Move down"), TRUE);
	      gtk_widget_set_sensitive( gtk_item_factory_get_widget(menubar_itemfactory, "/SongList/Clear"), TRUE);
	      gtk_widget_set_sensitive( gtk_item_factory_get_widget(menubar_itemfactory, "/SongList/Add to GQmpeg's Playlist"), TRUE);
	      break;
   }
}
